#include <Servo.h>

#include <XBee.h>


/*Valores de configuración*/
int pinledrecepcion = 13;
int pinbateria = 3;
int pinencendido = 4;
int pinenable = 12;
int pinacelerari = 10;
int pinmarchaatrasi = 11;
int pinacelerard = 8;
int pinmarchaatrasd = 9;
int pinclaxon = 7;
int pinServo1 = 6;
int pinServo2 = 5;

/*Valores para movimientos*/

int derecha = 0;
int adelante = 0;
int atras = 0;
int izquierda = 0;
int valor = 0;

int acelerando = 0;
int haciatras = 0;
int giroderecha = 0;
int giroizquierda = 0;
int claxonON = 0;
int paradoU = 0;

/*valores Camara*/

int centro1 = 0;
int centro2 = 0;

int camaraarriba = 0;
int camaraabajo = 0;
int camaraderecha = 0;
int camaraizquierda = 0;

XBee xbee = XBee();
 
Servo servo1;  // create servo object to control a servo 
Servo servo2;

void setup(){
  xbee.begin(9600);
  pinMode(pinbateria,INPUT);
  pinMode(pinencendido,OUTPUT);
  pinMode(pinenable,OUTPUT);
  pinMode(pinacelerari,OUTPUT);
  pinMode(pinmarchaatrasi,OUTPUT);
  pinMode(pinacelerard,OUTPUT);
  pinMode(pinmarchaatrasd,OUTPUT);
  pinMode(pinclaxon,OUTPUT);
  digitalWrite(pinenable,HIGH);
  servo1.attach(pinServo1);
  servo2.attach(pinServo2);
  centro1 = 95;
  centro2 = 40;
  servo1.write(centro1);
  servo2.write(centro2);
}
void acelerar(){
  digitalWrite(pinacelerari,HIGH);
  digitalWrite(pinacelerard,HIGH);
  delay(20);
}
void marchaatras(){
  digitalWrite(pinmarchaatrasi,HIGH);
  digitalWrite(pinmarchaatrasd,HIGH);
  delay(20);
}
void girarderecha(){
    digitalWrite(pinmarchaatrasd,HIGH);
    digitalWrite(pinacelerari,HIGH);
    delay(20);
}
void girarizquierda(){
  digitalWrite(pinmarchaatrasi,HIGH);
  digitalWrite(pinacelerard,HIGH);
  delay(20);
}
void parado(){
  digitalWrite(pinmarchaatrasi,LOW);
  digitalWrite(pinacelerari,LOW);
  digitalWrite(pinmarchaatrasd,LOW);
  digitalWrite(pinacelerard,LOW);
  delay(20);
}
void claxon(){
 digitalWrite(pinclaxon,HIGH);
 delay(100);
 digitalWrite(pinclaxon,LOW);
 delay(200);
 digitalWrite(pinclaxon,HIGH);
 delay(100);
 digitalWrite(pinclaxon,LOW);
 delay(200);
}
void loop(){ 
   claxonON = 0;
   camaraarriba = 0;
   camaraabajo = 0;
   camaraderecha = 0;
   camaraizquierda = 0;
    XBeeResponse response = XBeeResponse(); 
    Rx16Response rx16 = Rx16Response();
    xbee.readPacket();
    if (xbee.getResponse().isAvailable()) {
        if (xbee.getResponse().getApiId() == RX_16_RESPONSE) {
                xbee.getResponse().getRx16Response(rx16);
                derecha = rx16.getData(0);
                adelante = rx16.getData(1);
                atras = rx16.getData(2);
                izquierda = rx16.getData(3);
                claxonON = rx16.getData(4);
                camaraarriba = rx16.getData(5);
                camaraabajo = rx16.getData(6);
                camaraizquierda = rx16.getData(7);
                camaraderecha = rx16.getData(8);
                digitalWrite(pinledrecepcion,HIGH);
                delay(300);
                digitalWrite(pinledrecepcion,LOW);
        }
      }
      if(izquierda == 1){
        if(giroizquierda == 0){
          parado();
          girarizquierda();
          acelerando = 0;
          haciatras = 0;
          giroderecha = 0;
          giroizquierda = 1;
          paradoU = 0;
        }
      }else if(adelante == 1){
        if(acelerando == 0){
          parado();
          acelerar(); 
          acelerando = 1;
          haciatras = 0;
          giroderecha = 0;
          giroizquierda = 0;
          paradoU = 0;
        }
      }else if(atras == 1){
        if(haciatras == 0){
          parado();
          marchaatras();
          acelerando = 0;
          haciatras = 1;
          giroderecha = 0;
          giroizquierda = 0;
          paradoU = 0;
        }
      }else if(derecha == 1){
        if(giroderecha == 0){
          parado();
          girarderecha(); 
          acelerando = 0;
          haciatras = 0;
          giroderecha = 1;
          giroizquierda = 0;
          paradoU = 0;
        }
      }else{
        if(paradoU == 0){
          parado(); 
          acelerando = 0;
          haciatras = 0;
          giroderecha = 0;
          giroizquierda = 0;
          paradoU = 1;
        }
      }
      if(claxonON == 1){
        claxon();
        claxonON = 0;
      }
      if(camaraarriba == 1 && camaraabajo == 1 && camaraizquierda == 1 && camaraderecha == 1){
        servo1.write(centro1);
        servo2.write(centro2);
      }else if(camaraarriba == 1) {
        servo1.write(servo1.read()-10);
      }else if(camaraabajo == 1) {
        servo1.write(servo1.read()+10);
      }else if(camaraizquierda == 1) {
        servo2.write(servo2.read()-10);
      }else if(camaraderecha == 1) {
        servo2.write(servo2.read()+10);
      }
}
